local Saltworks = ...

-- Register common prefab nodes
Saltworks:registerAssetId("models/saltworks.fbx/Prefab/saltworksPart", "SALTWORKS_PREFAB")

Saltworks:register({
--Déclare que l'objet que l'on crée appartient à la class BUILDING
	DataType = "BUILDING",
--Déclare la classe de l'objet que l'on crée
	Id = "SALTWORKS",
--Déclaration du Nom  Sert dans l'ecran de selection du Mod
	Name = "SALTWORKS_NAME",
--Renseigne le champ description de l'objet sert a classer l'objet dans les menus
	Description = "SALTWORKS_DESC",
--Renseigne le champ Building Type. cela va permettre de classer l'objet dans les menus
	BuildingType = "GENERAL",
--renseigne le champ BuildingPartList de l'objet que l'on crée un peu plus loin	
	BuildingPartSetList = {
		{
			Name = "SALTWORKS_NAME",
                	BuildingPartList = { "SALTWORKS_PART" }
                }
        } 
--Renseigne le champ Nombre de villageois requis pour la construction. Ici inactivé pour le test
	--VillagerRequired = { Status = "NEWCOMER", Quantity = 8 }
})


-- Register the saltworks part
Saltworks:register({
	DataType = "BUILDING_PART",
	Id = "SALTWORKS_PART",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "SALTWORKS_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "WOOD", Quantity = 5 },
			{ Resource = "TOOL", Quantity = 2 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 1,
                RelatedJob = { Job = "SALT_WORKER", Behavior = "WORK_BEHAVIOR" },
                InputInventoryCapacity = {
			{ Resource = "BRINE", Quantity = 50 },
			{ Resource = "WOOD", Quantity = 50 }
                },
                ResourceListNeeded = {
			{ Resource = "BRINE", Quantity = 3 },
                	{ Resource = "WOOD", Quantity = 2 }
                },
                ResourceProduced = {
			{ Resource = "SALT2", Quantity = 1 }
                }
	}
})

Saltworks:registerPrefabComponent("models/saltworks.fbx/Prefab/saltworksPart", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {4, 6}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

Saltworks:registerPrefabComponent("models/saltworks.fbx/Prefab/saltworksPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 6 }
})

Saltworks:registerAssetId("models/saltworks.fbx/Prefab/saltworksPart/step_0/SmokeEmitter", "SALTWORKS_SMOKE_EMITTER_PREFAB")

Saltworks:registerPrefabComponent("models/saltworks.fbx/Prefab/saltworksPart", {
	DataType = "COMP_BUILDING_PART",
	FeedbackComponentListToActivate = {
		{ "SALTWORKS_SMOKE_EMITTER_PREFAB", "COMP_PARTICLE_EMITTER_TOGGLE" }
	}
})

-- Register particle system

Saltworks:registerPrefabComponent("models/saltworks.fbx/Prefab/saltworksPart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = false
})

Saltworks:registerPrefabComponent("models/saltworks.fbx/Prefab/saltworksPart/step_0/SmokeEmitter", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})

